type ChatType = 'private' | 'group' | 'temp' | 'guild';

interface IChatBase {
  chatType: ChatType;
}

interface IPrivateChat extends IChatBase {
  chatID: number;
  chatType: 'private';
}

interface IGroupChat extends IChatBase {
  chatID: number;
  chatType: 'group';
}

interface ITempChat extends IChatBase {
  chatID: {qq: number, group: number, toString: () => string};
  chatType: 'temp';
}

interface IGuildChat extends IChatBase {
  chatID: {channel: string, guild: string, toString: () => string};
  chatType: 'guild';
}

type IChat = IPrivateChat | IGroupChat | ITempChat | IGuildChat;

interface ILock {
  workon: number;
  feed: string[];
  threads: {
    [key: string]:
    {
      offset: string,
      id?: string,
      updatedAt: string,
      subscribers: IChat[],
    },
  };
}

interface IRedisConfig {
  redisHost: string;
  redisPort: number;
  redisExpireTime: number;
}
